;-------------------------------------------------------------------------------
;[`
sound_init
	lda	#%00011111
	sta	$4015
	lda	#$00
	sta	<$a0
	sta	<$a2
	sta	<$a4
	sta	<$a6
	sta	<$70
	sta	<$72
	sta	<$74
	sta	<$76

	lda	#$01
	sta	<$c0
	sta	<$c2
	sta	<$c4
	sta	<$c6

	ldy	#$00
sound_channel_set:
	lda	<$f0			;
	cmp	#$04			;
	beq	return4			;`lȏȂI
	asl	a
	tax				;2{xɊi[
	lda	sound_data_table,x
	sta	<$e0,x			;f[^Jnʒu
	inx
	lda	sound_data_table,x
	sta	<$e0,x			;f[^Jnʒu
	inc	<$f0
	jmp	sound_channel_set
return4
	lda	#$00
	sta	<$f0
	rts
;-------------------------------------------------------------------------------
sound_driver_start:

	lda	<$f0
	cmp	#$04
	beq	sound_channel_reset	;$f004Ȃ炨I
	asl	a
	tax
	dec	<$c0,x			;JE^炵
	bne	return1			;[ȊOȂJE^炵ĂI

	jsr	sound_data_read		;[ȂTEhǂݍ
	jsr	sound_software_enverope	;Gx[v`
	jsr	sound_data_write	;ăf[^o
	inc	<$f0			;̃`lݒ肵
	jmp	sound_driver_start	;͂߂ɖ߂

return1:
	lda	<$70,x			;\tgGxIh[
	cmp	#$01			;
	beq	return7			;IĂ΂̂܂܂I

	jsr	sound_software_enverope

return7:

	inc	<$f0			;̃`lݒ肵
	jmp	sound_driver_start	;͂߂ɖ߂

sound_channel_reset:

	lda	#$00
	sta	<$f0
	rts				;łI
;-------------------------------------------------------------------------------
frequency_set:

	lda	<$f0
	asl	a
	tax
	lda	<$B0,x			;Kf[^ǂݏo
	and	#%00001111		;4bito
	asl	a
	tay

	lda	<$f0
	cmp	#$03
	beq	noise_frequency_get	;S`lڂȂmCYg擾

	lda	psg_frequency_table,y	;PSGge[uLowǂݏo
	sta	<$D1,x			;
	iny				;yP₵
	lda	psg_frequency_table,y	;PSGge[uHighǂݏo
	sta	<$D0,x			;

oct_set1:

	lda	<$B0,x			;Kf[^ǂݏo
	lsr	a			;4bito
	lsr	a			;
	lsr	a			;
	lsr	a			;
	beq	freq_end		;[Ȃ炻̂܂܏I
	tay				;

oct_set2:

	lsr	<$D0,x			;IN^[uݒ
	ror	<$D1,x			;IN^[uݒ
	dey				;
	bne	oct_set2		;IN^[uJԂ

freq_end:

	rts

noise_frequency_get:
	lda	noise_frequency_table,y	;ge[uLowǂݏo
	sta	<$D1,x			;
	iny				;yP₵
	lda	noise_frequency_table,y	;ge[uHighǂݏo
	sta	<$D0,x			;
	jmp	oct_set1
;-------------------------------------------------------------------------------
sound_data_read:
	jsr	reg400x
	lda	#$00			;
	sta	<$70,x			;Gx[vf[^Zbg
	lda	<$80,x			;Gxf[^ԍ
	asl	a
	tay
	lda	enverope_table,y	;
	sta	<$60,x			;
	iny
	lda	enverope_table,y
	sta	<$61,x			;f[^Jnʒu

	jsr	reg400x
	lda	[$e0,x]			;f[^ǂݍ
	cmp	#$FF			;f[^$FFȂJԂƂ
	bne	neiro_set		;ꂾƃYFȂ
					;Aʂɂ܂Ȃ
	lda	loop_point_table,x
	sta	<$e0,x			;[vJnʒu Low
	inx
	lda	loop_point_table,x
	sta	<$e0,x			;[vJnʒu High
	jmp	sound_data_read

neiro_set:
	cmp	#$FE
	bne	oto_set
	jsr	sound_data_address
	lda	[$e0,x]			;Ff[^ǂݏo
	sta	$4000,y			;Ff[^
	pha				;aWۑ
	and	#%00001111		;4bito
	sta	<$80,x			;Gxf[^ԍ
	asl	a
	tay
	lda	enverope_table,y	;Gxf[^AhXݒ
	sta	<$60,x			;
	iny				;
	lda	enverope_table,y	;
	sta	<$61,x			;
	pla				;aW߂
	and	#%11110000		;4bito
	sta	<$50,x			;
	jsr	sound_data_address
	jsr	reg400x
	lda	[$e0,x]
	sta	$4001,y
	jsr	sound_data_address
	jmp	sound_data_read

oto_set:
	sta	<$B0,x			;͂܂
	jsr	sound_data_address
	lda	[$e0,x]			;ǂݏo
	sta	<$C0,x			;ۂ̃JEglƂȂ܂
	jsr	sound_data_address
	jsr	frequency_set		;gZbg
	rts

sound_data_address:
	inc	<$e0,x			;f[^AhX{P
	bne	return2			;ʂオ
	inc	<$e1,x			;f[^AhXS̈ʁij{P
return2:
	rts
;-------------------------------------------------------------------------------
sound_data_write:
	jsr	reg400x
	lda	<$D1,x			;Low Write
	sta	$4002,y
	lda	<$D0,x			;High Write
	sta	$4003,y
	rts
;-------------------------------------------------------------------------------
sound_software_enverope:
;Ɣėp̂郋[`ɂDDD
;ƃX}[gȕ@DDD͂

	jsr	reg400x
	lda	<$b0,x
	cmp	#$fc
	beq	return9

	lda	<$f0
	cmp	#$02
	beq	return6			;OpgȂ΂`

	lda	[$60,x]			;Gx[vf[^ǂݍ
	cmp	#$ff			;Ōォǁ[
	beq	return3			;ŌȂ炻̂܂܂܂

	ora	<$50,x			;Ff[^i4bitjƉ4bitőZ
	sta	$4000,y			;݁`
	jsr	enverope_address	;AhX₵
	rts				;܂
return9:
	lda	<$50,x
	sta	$4000,y
	rts
return3:
	inc	<$70,x
return6:
	rts

;-------------------------------------------------------------------------------
enverope_address:
	inc	<$60,x
	bne	return5
	inc	<$61,x
return5:
	rts
;--------------------------------------	
reg400x:
	lda	<$f0
	asl	a
	tax
	asl	a
	tay
	rts
;-------------------------------------------------------------------------------
